; - mIRC database system -
; - by Shocker - 
;      ---------------------------------
; ===< General comments about the script >===
;      ---------------------------------
; This script is splitted in two parts. One internal, 
; which should not be accessed from outside this file,
; and one general, which may be used as identifiers for
; other scripts. The reference for external scripts are 
; first, it's those where you may mess around the way you
; like. 
; -- Usage
; NOTE: database name will be the filename the script uses. 
; NOTE: all params are required. 
; adding an item: 
; $add_item(database name, -q keyword(s) -a answer)
; the identifier will return a value, $true if successful, 
; if it fails, it returns Database is full if the file size exceeds
; 64K, or Format error if syntax is wrong.  
; deleting an item:
; $delete_item(database name, -q keyword(s) OR -a answer)
; the identifier will return Entry deleted if successful, or Format error 
; or No such item
; finding an entry:
; $db_lookup(database name, keyword(s))
; the identifier will return the -a entry, or $false if 
; entry is not found.
; rehashing the database:
; $rehash_db(database name)
; returns $true if successful, $false if not
; Comment: due to the structure of the ini format, like
; the file size limit, and some internal scripting stuff,
; it is recomended to rehash the database from time to time,
; for insance on connect or on disconnect. 
; --< get an answer from the file >--
; - remember this stuff is called from 
; - some other script that notices the
; - questions, so $1 must be the chan
; - to display the answer in
; --< Format: $db_lookup(keyword(s)) >--
#dbfaq off
alias db_lookup {
  set %_database_name $1
  var %_tmp = $_look_for_answer($2-)
  if (!%_tmp) { 
    return This question has not been recorded in the database.
    ; do some stuff to record the q and count the
    ; number of times it is asked
  }
  else return %_tmp
}
; --< Add a new item to the file. >--
; --< Syntax: $add_item(database name, -q question -a answer) >--
alias add_item {
  set %_database_name $1
  ; here's some kewl detail ;)
  if ($_add_item($2-)) return Question/Answer successfully added.
  ; if it don't work, maybe we should check if the file is full?
  ; if you get this, try rehash it, and readd. but make sure
  ; you don't make an infinite loop doing this, i smell a huge 
  ; spinlock, that is why i choose not to do it automatically.
  elseif ($_db_is_to_big) return Database is full. Try rehashing (.db_rehash)
  ; well, if that didn't help, then there must have been a format error.
  else return Incorrect usage, correct syntax: .add_item -q <question> -a <answer>
}
; - the ability to delete items are allways nice
; --< Syntax: $delete_item(database name,  <-q <question> | -a <answer>>) >--
alias delete_item {
  set %_database_name $1
  var %deleted = $_delete_item($2-)
  if (%deleted) return Question/Answer successfully deleted.
  elseif (%deleted == wrong_format) return Incorrect usage, correct syntax: .delete_item -q <question>
  else return No such item.
}
; - db maintainance should be done on regular basis. 
; --< Syntax: 
alias rehash_db { 
  if ($1 != $null) set %_database_name $1
  if ($_rehash_db) return Rehash completed.
  else return Rehash failed.
}
; ====< Here goes all the internal stuff. >====
; - it should be able to preform maintainance on the file, 
; - removing null entrys and restoring the order the items
; - are placed in, hopefully placing the most frequently used
; - entrys first in the file
; --< format: /_rehash_db [dbfilename] >--
alias _rehash_db {
  var %_dbname = glibberish
  var %_dbname.old = bullshit
  var %_tempdb = ini\temp.ini
  if ($1 != $null) %_dbname = $1
  else %_dbname = $_db_file_name
  ; *phew* here goes..
  ; okey, we know that if some of the values are no_value it is a
  ; deleted item. i think we should rename the db file to <dbname.old>
  ; and then build a temp file based on this one, but without the no_value
  ; (e.g. deleted) items, and then build the db from scratch in the order
  ; with the most accessed items first i wonder how the heck that is supposed
  ; to be done, tho.. i guess i'll have to think about that one....
  ; okey, lets just get rid of the dead items for now, then...
  %_dbname.old = %_dbname $+ [ $replace($date ,/,_) ]
  var %_something_might_screw_this_up = %_dbname.old $+ $chr(45) $+ $rand(1,10000)
  ;   echo -s %_something_might_screw_this_up
  if ($isfile(%_dbname.old)) { .rename %_dbname.old %_something_might_screw_this_up }
  .rename %_dbname %_dbname.old
  ; wow, that went good.. okey, lets start building the temp database
  var %_counter.1 = 1
  var %_counter.2 = 0
  while (($readini(%_dbname.old, [ faq $+ [ %_counter.1 ] ] , question) != $null)) {
    if ($readini(%_dbname.old, [ faq $+ [ %_counter.1 ] ] , question) != no_value ) {
      inc %_counter.2 
      writeini %_tempdb [ faq $+ [ %_counter.2 ] ] question $readini(%_dbname.old, [ faq $+ [ %_counter.1 ] ] , question)
      writeini %_tempdb [ faq $+ [ %_counter.2 ] ] answer $readini(%_dbname.old, [ faq $+ [ %_counter.1 ] ] , answer)
      writeini %_tempdb [ faq $+ [ %_counter.2 ] ] number_of_times_accessed $readini(%_dbname.old, [ faq $+ [ %_counter.1 ] ] , number_of_times_accessed)
    }
    inc %_counter.1
  }
  writeini %_tempdb internal number_of_items %_counter.2
  ; here we should add the feature that sorts the db based on the  
  ; number_of_times_accessed thingy.. *sigh* wish there where a good
  ; array function in this scripting language....
  ; but there aint, so i'll have to think about how to do this..
  ; so for now.. we gracefully skip it
  .rename %_tempdb %_dbname
  return $true
}
; This is aliases that should NOT be accessed from anywhere but the internal
; script. 
; - check the db for questions matching the one asked.
; - it should return the answer if found, else it should
; - return false
; --< format: $_look_for_answer(question) >--
alias -l _look_for_answer { 
  tokenize 32, $1-
  var %_counter = 0
  while (%_counter < $_number_of_items) {
    inc %_counter
    if ( $readini($_db_file_name, [ faq $+ [ %_counter ] ] , question) == $null ) return $false
    if ( $readini($_db_file_name, [ faq $+ [ %_counter ] ] , question) == $1- ) {
      ; we have found a match
      writeini $_db_file_name [ faq $+ [ %_counter ] ] number_of_times_accessed $calc( $readini( $_db_file_name , [ faq $+ [ %_counter ] ] , number_of_times_accessed) + 1 )
      return $readini( $_db_file_name, [ faq $+ [ %_counter ] ] , answer)
    }
  }
  return $false
}
; - add a new item to the database. if any no_value 
; - enterys are found, replace the no_value with this one
; --< format: /_add_item -q <question> -a <answer> >--
alias -l _add_item {
  tokenize 32, $1-
  if ($_file_is_to_big) { return $false }
  elseif (!$_get_question($1-)) { return $false }
  elseif (!$_get_answer($1-)) { return $false }
  writeini $_db_file_name [ faq $+ [ $calc($_number_of_items + 1) ] ] question $_get_question($1-)
  writeini $_db_file_name [ faq $+ [ $calc($_number_of_items + 1) ] ] answer $_get_answer($1-)
  writeini $_db_file_name [ faq $+ [ $calc($_number_of_items + 1) ] ] number_of_times_accessed 0
  writeini $_db_file_name internal number_of_items $calc($_number_of_items + 1)
  return $true
}
; - it should be able to delete entrys
; --< format: /_delete_item <-q question | -a answer | -n item_number> >--
; - the -n item_number will be implemended at a later stage
alias -l _delete_item { 
  tokenize 32, $1-
  if ($1 == -q) {
    ; we are going to look for a question
    var %_counter = 1
    while ($readini($_db_file_name, [ faq $+ [ %_counter ] ] , question) != $null) {
      if ($2- == $readini($_db_file_name, [ faq $+ [ %_counter ] ] , question)) {
        writeini $_db_file_name [ faq $+ [ %_counter ] ] question no_value
        writeini $_db_file_name [ faq $+ [ %_counter ] ] answer no_value
        goto the_removal_ended_successfully
      }
      inc %_counter
    }
    return $false
  }
  elseif ($1 == -a) {
    ; we are going to look for an answer
    var %_counter = 1
    while ($readini($_db_file_name, [ faq $+ [ %_counter ] ] , answer) != $null) {
      if ($2- == $readini($_db_file_name, [ faq $+ [ %_counter ] ] , answer)) {
        writeini $_db_file_name [ faq $+ [ %_counter ] ] question no_value
        writeini $_db_file_name [ faq $+ [ %_counter ] ] answer no_value
        goto the_removal_ended_successfully
      }
      else { %_counter = %_counter + 1 }
    }
    return $false
  }
  else {
    ; wrong format
    return wrong_format
  }
  :the_removal_ended_successfully
  return $true
}
; - it should use internal stuff to keep track of the filesize
; - and warn if it is full upon adding a new item, it should allso
; - keep track of the number of items and stuff
alias -l _is_file_to_big { 
  if ($calc( [ $file($_db_file_name).size ] / 1024) < 64) { return $false } 
  else { return $true }
}
alias -l _get_question { 
  tokenize 32, $1-
  if (-q isin $1-) {
    var %_return_value = $null
    var %_counter = 0
    var %_just_a_var = $null
    while ($true) {
      inc %_counter
      %_just_a_var = [ $ $+ [ %_counter ] ]
      if ((%_just_a_var == -a) || (%_just_a_var == $null)) break
      if (%_just_a_var == -q) continue
      %_return_value = %_return_value %_just_a_var
    }
    return %_return_value
  }
  return $false
}
alias -l _get_answer { 
  tokenize 32, $1-
  if (-a isin $1-) {
    var %_return_value = $null
    var %_counter = 0
    var %_just_a_var = $null
    while ($true) {
      inc %_counter
      %_just_a_var = [ $ $+ [ %_counter ] ]
      if (%_just_a_var != -a) continue
      else dec %_counter
      while ($true) {
        inc %_counter
        %_just_a_var = [ $ $+ [ %_counter ] ]
        if (%_just_a_var == $null) goto we_are_finally_going_out_of_this_endless_loop
        if (%_just_a_var == -a) continue
        %_return_value = %_return_value %_just_a_var
      }
    }
    :we_are_finally_going_out_of_this_endless_loop
    return %_return_value
  }
  return $false
}
alias -l _number_of_items { 
  if ($readini($_db_file_name, internal, number_of_items) == $null) return 0
  else return $readini($_db_file_name, internal, number_of_items) 
}
alias -l _db_file_name { return %_database_name }
#dbfaq end
